/***************************************************************************
 *   Copyright (C) 2006 by Gerd v. Egidy                                   *
 *   gve@intra2net.com                                                     *
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License version   *
 *   2.1 as published by the Free Software Foundation.                     *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU Lesser General Public License for more details.                   *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef __LIBT2N_SOCKET_CLIENT
#define __LIBT2N_SOCKET_CLIENT

#include "client.hxx"
#include "socket_handler.hxx"

namespace libt2n
{

class socket_client_connection : public client_connection, public socket_handler
{
    static const int max_retries_default=3;

    private:
        void real_write(const std::string& data)
            { socket_write(data); }

        void connect();

        int max_retries;

        std::string path;
        std::string server;
        int port;

    public:
        socket_client_connection(const std::string& _server, int _port, int _max_retries=max_retries_default);
        socket_client_connection(const std::string& _path, int _max_retries=max_retries_default);

        void fill_buffer(long long usec_timeout=-1)
            { socket_handler::fill_buffer(buffer,usec_timeout); }

        void close();
};

}

#endif
